(require 'sgml-mode)
(load "psgml-html")                   ; For html-font-lock-keywords

(defvar sgml-font-lock-keywords html-font-lock-keywords)
(put 'sgml-mode 'font-lock-defaults '(sgml-font-lock-keywords))

;; font-lock setup for various emacsen: XEmacs, Emacs 19.29+, Emacs
<19.29.
;; By Ulrik Dickow <dickow@nbi.dk>.  (Last update: 05-Sep-1995).
(cond   ((string-match "XEmacs\\|Lucid" (emacs-version)) ; XEmacs/Lucid
         (put major-mode 'font-lock-keywords-case-fold-search t))
        ;; XEmacs (19.13, at least) guesses the rest correctly.
        ;; If any older XEmacsen don't, then tell me.
        ;;
        ((string-lessp "19.28.89" emacs-version) ; Emacs 19.29 and later
         (make-local-variable 'font-lock-defaults)
         (setq font-lock-defaults '(sgml-font-lock-keywords t t)))
        ;;
        (t                              ; Emacs 19.28 and older
         (make-local-variable 'font-lock-keywords-case-fold-search)
         (make-local-variable 'font-lock-keywords)
         (make-local-variable 'font-lock-no-comments)
         (setq font-lock-keywords-case-fold-search t)
         (setq font-lock-keywords sgml-font-lock-keywords)
         (setq font-lock-no-comments t)))
